package it.uniroma1.dis.mfis.redia.verifint.control.provers.analysis.classDiagram;

import java.io.*;

import it.uniroma1.dis.mfis.redia.verifint.control.ExecutionProperties;
import it.uniroma1.dis.mfis.redia.verifint.control._dataTypes.ProvingResult;
import it.uniroma1.dis.mfis.redia.verifint.control._exceptions.ApplicationException;
import it.uniroma1.dis.mfis.redia.verifint.control.io.XmlMarshaller;
import it.uniroma1.dis.mfis.redia.verifint.control.provers.Prover;
import it.uniroma1.dis.mfis.redia.verifint.control.provers._constants.Alloy4Constants;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams.CCDDiagram;

import edu.mit.csail.sdg.alloy4whole.*;
import edu.mit.csail.sdg.alloy4.*;

public class CCDAlloy4Prover extends Prover {
	/*
	 * La classe non segue i passi della classe per lanciare Prover9
	 * in quanto non funzionava il lancio dell'applicazione.
	 * Allora si è deciso di sfruttare il codice open source di Alloy4
	 * chiamando così direttamente i metodi offerti.
	 */

	public CCDAlloy4Prover(CCDDiagram diagram) {
		super(diagram);
		super.setExecutionProperties(
				EMPTY_PROVER_PROGRAM_PATH,
				EMPTY_COMMAND_STRING,
				Alloy4Constants.ALLOY_4_XSLT_PATH_KEY);
	}

	public ProvingResult prove(String goal) { return null; } //non serve

	public ProvingResult proveAlloy4(String nomeDiagramma) throws Err {
		if (this.getXsltPath().equals(EMPTY_XSLT_PATH)) {
			throw new IllegalStateException(
					EXECUTION_PROPERTIES_NOT_SET_EXCEPTION_MESSAGE);
		}
		
		String diagramXml = new XmlMarshaller().marshal((CCDDiagram)this.diagram);
		String nomeFile = nomeDiagramma + ".als";
		PrintWriter pw = null;
		String nome_file_tmp = ExecutionProperties.getInstance().getProperty(
			Alloy4Constants.ALLOY_4_TMP_PATH_KEY) + nomeFile;
		
		try {
			FileWriter fw = new FileWriter(nome_file_tmp);
			pw = new PrintWriter(fw);
			pw.println(super.createProverProgramInput(diagramXml)); 
			pw.close();
			fw.close();
		}
		catch(Exception e) {
			throw new ApplicationException(e.getMessage());
		}
		
		String proverInput = nome_file_tmp;
		return Alloy4External.startAlloy4(proverInput);
	}

	public String getAlloyInput(String nomeDiagramma) throws IOException {
		String result = "";
		FileReader f = new FileReader(ExecutionProperties.getInstance().getProperty(
			Alloy4Constants.ALLOY_4_TMP_PATH_KEY) + nomeDiagramma + ".als");
		BufferedReader br = new BufferedReader(f);
		String aux = br.readLine();
		while(aux != null) {
			result = result + aux + "\n";
			aux = br.readLine();
		}
		br.close();
		f.close();
		return result;
	}
}
