package it.uniroma1.dis.mfis.redia.verifint.view.graphics.gui._guiutils;

import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;
import java.util.*;

public class SpecialTableModel extends AbstractTableModel {
	
	private String[] colNames;
	private Vector data;
	private boolean editable = true;
	
	public SpecialTableModel(String[] col) {
		colNames = col;
		data = new Vector();
	}
	
	public int getRowCount() {
		return data.size();
	}
	
	public int getColumnCount() {
		return colNames.length;
	}
	
	public String getColumnName(int i) {
		return colNames[i];
	}
	
	public Object getValueAt(int row, int col) {
		try {
      		Object[] riga = (Object[]) data.get(row);
      		return riga[col];
    	}
    	catch(ArrayIndexOutOfBoundsException err) {
      		err.printStackTrace();
      		return null;
    	}
	}
	
	public Class getColumnClass(int c) {
		return getValueAt(0,c).getClass();
	}
	
	public void setValueAt(Object value, int row, int col) {
		Object[] riga = (Object[]) data.get(row);
		riga[col] = value;
		data.setElementAt(riga,row);
		fireTableCellUpdated(row,col);
	}
	
	public boolean isCellEditable(int row, int col) {
		return editable;
	}
	
	public void addRow(Object[] row) {
		data.add(row);
	}
	
	public void removeLastRow() {
		int lastIndex = (data.size())-1;
		if(lastIndex >= 0) data.remove(lastIndex);
	}
	
	public void clear() {
		data.clear();
	}

	public void setEditable(boolean edit) {
		editable = edit;
	}
}
