package it.uniroma1.dis.mfis.redia.verifint.view.graphics.gui.frames.classDiagram;

import it.uniroma1.dis.mfis.redia.verifint.view.graphics.gui._guiutils.SpecialTableModel;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.types.CTBaseType;

import javax.swing.*;
import java.awt.*;

public class AttributiTable extends JTable {
	
	SpecialTableModel modello;
	JComboBox typesBox;
	JComboBox visibBox;
	JComboBox cardiBox;
	final String[] colNames = {"Name","Type","Cardinality","Visibility"};
	final String[] types = {CTBaseType.STRING_TYPE.getName(),CTBaseType.INTEGER_TYPE.getName(),
				CTBaseType.POSITIVE_INTEGER_TYPE.getName(),CTBaseType.NON_NEGATIVE_INTEGER_TYPE.getName(),
				CTBaseType.BOOLEAN_TYPE.getName(),CTBaseType.FLOAT_TYPE.getName(),
				CTBaseType.CHARACTER_TYPE.getName(),CTBaseType.BYTE_TYPE.getName(),
				CTBaseType.DATE_TYPE.getName(),CTBaseType.DATE_TIME_TYPE.getName()};
	final String[] visibilities = {"private","public","protected","package"};
	final String[] cardinalities = {"1,1","0,1","0,*","1,*"};
	DefaultCellEditor editorTypes;
	DefaultCellEditor editorVisib;
	DefaultCellEditor editorCardi;
	
	public AttributiTable() {
		modello = new SpecialTableModel(colNames);
		this.setModel(modello);
		typesBox = new JComboBox(types);
		cardiBox = new JComboBox(cardinalities);
		visibBox = new JComboBox(visibilities);
		editorTypes = new DefaultCellEditor(typesBox);
		editorCardi = new DefaultCellEditor(cardiBox);
		editorVisib = new DefaultCellEditor(visibBox);
		this.getColumnModel().getColumn(1).setCellEditor(editorTypes);
		this.getColumnModel().getColumn(2).setCellEditor(editorCardi);
		this.getColumnModel().getColumn(3).setCellEditor(editorVisib);
		this.setPreferredScrollableViewportSize(new Dimension(492,170));
		this.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	}
	
	public void clear() {
		modello.clear();
	}
	
	public void addRow() {
		Object[] newRow = {"",CTBaseType.INTEGER_TYPE.getName(),"1,1","private"};
		modello.addRow(newRow);
	}
	
	public void removeLastRow() {
		modello.removeLastRow();
	}
}
