package it.uniroma1.dis.mfis.redia.verifint.view.graphics.gui.frames.classDiagram;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import java.util.ArrayList;
import java.util.HashSet;

import it.uniroma1.dis.mfis.redia.verifint.view.graphics.engine.Drawable;
import it.uniroma1.dis.mfis.redia.verifint.view.graphics.engine.Edge;
import it.uniroma1.dis.mfis.redia.verifint.view.graphics.engine.Figure;
import it.uniroma1.dis.mfis.redia.verifint.view.graphics.engine.Frame;
import it.uniroma1.dis.mfis.redia.verifint.view.graphics.engine.Label;
import it.uniroma1.dis.mfis.redia.verifint.view.graphics.engine.RenderingPane;

public class ContentTabPane extends JPanel {

	public static final int CLASS_TYPE = 0;
	public static final int ASSOCIATION_TYPE = 1;
	public static final int ISA_TYPE = 2;

	HashSet<Drawable> drawableObjects = new HashSet<Drawable>();
	RenderingPane renderingPane = new RenderingPane();
	JScrollPane renderingJsp = new JScrollPane(renderingPane);
	
	JTextArea classArea = new JTextArea("Classes:\n");
	JScrollPane classJsp = new JScrollPane(classArea);

	JTextArea associationArea = new JTextArea("Associations:\n");
	JScrollPane associationJsp = new JScrollPane(associationArea);

	JTextArea isaArea = new JTextArea("Isa:\n");
	JScrollPane isaJsp = new JScrollPane(isaArea);

	JTextArea alloyInArea = new JTextArea("Alloy4 input");
	JScrollPane alloyInJsp = new JScrollPane(alloyInArea);

	JTextArea alloyOutArea = new JTextArea("Alloy4 output");
	JScrollPane alloyOutJsp = new JScrollPane(alloyOutArea);
	
	JPanel sudPnl = new JPanel();
	JPanel estPnl = new JPanel();

	public ContentTabPane() {
		classArea.setColumns(15);
		classArea.setEditable(false);

		associationArea.setColumns(15);
		associationArea.setEditable(false);

		isaArea.setColumns(15);
		isaArea.setEditable(false);

		alloyInArea.setRows(8);
		alloyInArea.setEditable(false);

		alloyOutArea.setRows(8);
		alloyOutArea.setEditable(false);
		
		estPnl.setLayout(new GridLayout(3,1));
		estPnl.add(classJsp);
		estPnl.add(associationJsp);
		estPnl.add(isaJsp);
		
		sudPnl.setLayout(new GridLayout(1,2));
		sudPnl.add(alloyInJsp);
		sudPnl.add(alloyOutJsp);

		this.setLayout(new BorderLayout());
		this.add(renderingJsp,BorderLayout.CENTER);
		this.add(estPnl,BorderLayout.EAST);
		this.add(sudPnl,BorderLayout.SOUTH);
	}

	public HashSet<Drawable> getDrawableObj() {
		return drawableObjects;
	}
	
	public RenderingPane getRenderingPane() {
		return renderingPane;
	}

	public void setRenderingPane(RenderingPane unRP) {
		renderingPane = unRP;
	}

	public void updateAlloyInArea(String update) {
		alloyInArea.setText(update);
		this.updateUI();
	}
	public void updateAlloyOutArea(String update) {
		alloyOutArea.setText(update);
		this.updateUI();
	}
	public void updateComponentsArea(int type, String update) {
		switch(type) {
			case 0: classArea.append("  - " + update + "\n"); break;
			case 1: associationArea.append("  - " + update + "\n"); break;
			case 2: isaArea.append("  - " + update + "\n"); break;
			default: break;
		}
		this.updateUI();
	}
	
	public void deleteCompFromArea(int type, String string) {
		String area = null;
		switch(type) {
			case 0: area = classArea.getText(); classArea.setText(""); break;
			case 1: area = associationArea.getText(); associationArea.setText(""); break;
			case 2: area = isaArea.getText(); isaArea.setText(""); break;
			default: area = ""; break;
		}
		String[] split = area.split("\n");
		for(int i = 0; i < split.length; i++) {
			//riscrivo le linee esclusa quella da eliminare
			switch(type) {
				case 0: if(!split[i].equals("  - " + string))
						classArea.append(split[i] + "\n"); 
						break;
				case 1: if(!split[i].equals("  - " + string))
						associationArea.append(split[i] + "\n"); 
						break;
				case 2: String[] isa = string.split("-");
						boolean ok = true;
						for(int j = 0; j<isa.length;j++)
						if(split[i].contains(isa[j])) ok = false;
						if(ok) isaArea.append(split[i] + "\n");
						isaArea.append(split[i] + "\n"); 
						break;
				default: break;				
			}			
		}
		this.updateUI();
	}
}
