package it.uniroma1.dis.mfis.redia.verifint.view.graphics.gui.frames.classDiagram;

import  it.uniroma1.dis.mfis.redia.verifint.view.graphics.gui._guiutils.UnspecifiedParameterException;
import  it.uniroma1.dis.mfis.redia.verifint.model.analysis.types.CTBaseType;

import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.util.*;

public class OperazioneListener implements ActionListener {
	
	OperazioneFrame frame;
	
	public static final String OK = "Ok";
	public static final String ANNULLA = "ANNULLA";
	
	public OperazioneListener(OperazioneFrame unFrame) {
		frame = unFrame;
	}
	
	
	public void actionPerformed(ActionEvent e) {
		String com = e.getActionCommand();
		if(com == OK) {
			try {
				componiOperazione();
				frame.dispose();
			} 
			catch(UnspecifiedParameterException err) {
				JOptionPane.showMessageDialog(frame, err.message);
			}
		}
		if(com == ANNULLA) {
			frame.dispose();
		}
	}

	private void componiOperazione() throws UnspecifiedParameterException {
		String operazione = "";
		String parametri = "";
		String nomeOperazione = frame.nomeTxt.getText();
		if(nomeOperazione.equals("")) 
			throw new UnspecifiedParameterException("Operation name not valid");
		HashMap map = CTBaseType.getBaseTypes();	
		String tipo = (String)frame.typeBox.getSelectedItem();
		CTBaseType returnType;
		if(tipo.equals("Void")) returnType = CTBaseType.UNDEFINED_TYPE;
		else returnType = (CTBaseType)map.get(tipo);
		int rows = frame.parPnl.table.getRowCount();
		for (int i = 0; i < rows; i++) {//prendo i parametri
			if (i != 0) parametri = parametri + ", ";
			String nomeParametro = (String)frame.parPnl.table.getValueAt(i,0);
			if(nomeParametro.equals("")) 
				throw new UnspecifiedParameterException("Parameter name not valid");
			CTBaseType paramType = (CTBaseType)map.get((String)frame.parPnl.table.getValueAt(i,1));
			parametri = parametri + nomeParametro + ": " + paramType.getName();
		}
		//se non ha parametri
		if(parametri.equals("")) parametri = "void";
		String ritorno = returnType.getName();
		if(ritorno.equals("?")) ritorno = "void";
		operazione = nomeOperazione + "(" + parametri + "): " + ritorno;
		frame.classFrame.operPnl.table.addRow(operazione);
		frame.classFrame.operPnl.table.updateUI();
		if(frame.classFrame.operPnl.table.getRowCount() == 1) 
			frame.classFrame.operPnl.removeBtn.setEnabled(true);
	}
}
