package it.uniroma1.dis.mfis.redia.verifint.view.graphics.gui.frames.classDiagram;

import it.uniroma1.dis.mfis.redia.verifint.view.graphics.gui._guiutils.SpecialTableModel;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.types.CTBaseType;

import javax.swing.*;
import java.awt.*;

public class ParametriTable extends JTable {
	
	SpecialTableModel modello;
	final String[] colNames = {"Name","Type"};
	final String[] types = {CTBaseType.STRING_TYPE.getName(),CTBaseType.INTEGER_TYPE.getName(),
				CTBaseType.POSITIVE_INTEGER_TYPE.getName(),CTBaseType.NON_NEGATIVE_INTEGER_TYPE.getName(),
				CTBaseType.BOOLEAN_TYPE.getName(),CTBaseType.FLOAT_TYPE.getName(),
				CTBaseType.CHARACTER_TYPE.getName(),CTBaseType.BYTE_TYPE.getName(),
				CTBaseType.DATE_TYPE.getName(),CTBaseType.DATE_TIME_TYPE.getName()};
	JComboBox typesBox;
	DefaultCellEditor editorTypes;
	
	public ParametriTable() {
		modello = new SpecialTableModel(colNames);
		this.setModel(modello);
		typesBox = new JComboBox(types);
		editorTypes = new DefaultCellEditor(typesBox);
		this.getColumnModel().getColumn(1).setCellEditor(editorTypes);
		this.setPreferredScrollableViewportSize(new Dimension(192,160));
		this.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	}
	
	public void clear() {
		modello.clear();
	}
	
	public void addRow() {
		Object[] newRow = {"",CTBaseType.STRING_TYPE.getName()};
		modello.addRow(newRow);
	}
	
	public void removeLastRow() {
		modello.removeLastRow();
	}
}
