package it.uniroma1.dis.mfis.redia.verifint.view.graphics.gui.frames.classDiagram;

import it.uniroma1.dis.mfis.redia.verifint.view.graphics.engine.RenderingPane;

import it.uniroma1.dis.mfis.redia.verifint.view.graphics.engine.Drawable;
import it.uniroma1.dis.mfis.redia.verifint.view.graphics.engine.Edge;
import it.uniroma1.dis.mfis.redia.verifint.view.graphics.engine.Figure;
import it.uniroma1.dis.mfis.redia.verifint.view.graphics.engine.Frame;
import it.uniroma1.dis.mfis.redia.verifint.view.graphics.engine.Label;
import it.uniroma1.dis.mfis.redia.verifint.view.graphics.engine.RenderingPane;

import java.util.TreeSet;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class PopupMenu extends JPopupMenu {
	
	String nome;
	
	JMenuItem classItem = new JMenuItem("New Class");
	JMenuItem assItem = new JMenuItem("New Association");
	JMenuItem genItem = new JMenuItem("New IS-A");
	JMenuItem removeClassItem = new JMenuItem("Remove Class");
	JMenuItem removeAssItem = new JMenuItem("Remove Association");
	JMenuItem removeGenItem = new JMenuItem("Remove IS-A");
	
	PopupMenuListener ascoltatore = new PopupMenuListener(this);
	
	
	public PopupMenu(RenderingPane renderingpane,String nomeClasse){
	
			super("menu");
			
			nome = nomeClasse;
			
			Set<Drawable> drawableObjects = renderingpane.getDrawableObjects();

			removeAssItem.setEnabled(false);
			removeGenItem.setEnabled(false);
			int countClassi = 0; 
			for(Drawable draw : drawableObjects){
				if(draw instanceof Edge){
					Edge arco = (Edge) draw;
					String classi = arco.getNomeClass();
					if(classi.contains(nomeClasse)){
						if((arco.getStyle() == Edge.STYLE_SIMPLEASSOCIATION) || (arco.getStyle() == Edge.STYLE_HAS)){
							removeAssItem.setEnabled(true);
							
						}
						if(arco.getStyle() == Edge.STYLE_ISA){
							String padre = classi.substring(0,classi.indexOf("-"));
							if(padre.equals(nome)) removeGenItem.setEnabled(true);
							
						}	
					}
				}
				if(draw instanceof Figure) countClassi++;
			}
			if(countClassi <= 1) {
				assItem.setEnabled(false);
				genItem.setEnabled(false);
			}
			this.add(assItem);
			this.add(genItem);
			this.addSeparator();
			this.add(removeClassItem);
			this.add(removeAssItem);			
			this.add(removeGenItem); 
			assItem.addActionListener(ascoltatore);
			assItem.setActionCommand(ascoltatore.ASSOCIATION);
			genItem.addActionListener(ascoltatore);
			genItem.setActionCommand(ascoltatore.ISA);
			//specItem.addActionListener(ascoltatore);
			//specItem.setActionCommand(ascoltatore.SPECIFICATION);
			//metodi eliminazione
			removeClassItem.addActionListener(ascoltatore);
			removeClassItem.setActionCommand(ascoltatore.DELETECLASS);
			removeAssItem.addActionListener(ascoltatore);
			removeAssItem.setActionCommand(ascoltatore.DELETEASS);
			removeGenItem.addActionListener(ascoltatore);
			removeGenItem.setActionCommand(ascoltatore.DELETEISA);
			
	}
	
	public String getNome(){
		return nome;
	}
}
