package it.uniroma1.dis.mfis.redia.verifint.view.graphics.gui.frames.classDiagram;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import it.uniroma1.dis.mfis.redia.verifint.control.ClassDiagramController;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams.CCDDiagram;
import it.uniroma1.dis.mfis.redia.verifint.view.graphics.gui._guiutils.UnspecifiedParameterException;
import it.uniroma1.dis.mfis.redia.verifint.control.Archive;
import it.uniroma1.dis.mfis.redia.verifint.control._dataTypes.ProvingResult;

import edu.mit.csail.sdg.alloy4.Err;

import java.io.*;

public class PopupMenuListener implements ActionListener{

	public static final String ASSOCIATION = "ASS";
	public static final String ISA = "GEN";
	public static final String SPECIFICATION = "SPEC";
	public static final String DELETECLASS = "DELETECLASS";
	public static final String DELETEASS = "DELETEASS";
	public static final String DELETEISA = "DELETEISA";
	public static final String NOTE = "NOTE";

	//altri identificatori di diagrammi futuri
	//tipo : "public static final String STNDIAGRAM = "STN";"

	
	private PopupMenu popup;

	public PopupMenuListener(PopupMenu unPopup){
		popup = unPopup;
	}

	public void actionPerformed(ActionEvent e) {
		String com = e.getActionCommand();
		String nome = popup.getNome();
		if(com == ASSOCIATION){ 
			AssociationFrame assFrame = new AssociationFrame(nome);
		}
		if(com == ISA){
			ISAFrame isaFrame = new ISAFrame(nome);
			
		}if(com == DELETECLASS){
			try {
				cancellaClassePopUp(nome);
			}
			catch(UnspecifiedParameterException unspecErr) {
				JOptionPane.showMessageDialog(null,unspecErr.message);
			}
			catch (Err err) {
				JOptionPane.showMessageDialog(null,err.toString());
			}
			
		}
		if(com == DELETEASS){
			DeleteAssFrame delAss = new DeleteAssFrame(nome);
		}
		if(com == DELETEISA){
			DeleteISAFrame delISa = new DeleteISAFrame(nome);
		}
		if(com == SPECIFICATION){ 
			//non implementato
		}
	}

	private static void cancellaClassePopUp(String nome) throws UnspecifiedParameterException, Err {
		Archive archive = Archive.getInstance();
		JTabbedPane jtp = PrincipaleFrame.getJTP();
		String nomeDiagramma = jtp.getTitleAt(jtp.getSelectedIndex());
		CCDDiagram diagram = (CCDDiagram)archive.getDiagram(nomeDiagramma);
		DeleteClassListener.cancellaOggettoClasse(nome);
		ProvingResult proving = provaFormale();
		String fileAls = "";
		try {
			fileAls = ClassDiagramController.getAlloyInputString(diagram);
		}
		catch (IOException e) {
			throw new UnspecifiedParameterException("Cannot read file " + nomeDiagramma + ".als");
		}
		DeleteClassListener.cancellaDisegnoClasse(nome,true,fileAls,proving.proof);
		if(!proving.proven) 
			throw new UnspecifiedParameterException("Unsatisfiable diagram!\nPlease check prover output in the box below");
	}

	private static ProvingResult provaFormale() throws Err {
		Archive archive = Archive.getInstance();
		JTabbedPane jtp = PrincipaleFrame.getJTP();
		CCDDiagram diagram = (CCDDiagram)archive.getDiagram(jtp.getTitleAt(jtp.getSelectedIndex()));
		return ClassDiagramController.verificaFormale(diagram);
	}
}

