package it.uniroma1.dis.mfis.redia.verifint.view.graphics.gui.frames.classDiagram;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

import it.uniroma1.dis.mfis.redia.verifint.view.graphics.gui._guiutils.FrameUtil;

public class PrincipaleFrame extends JFrame {

	JMenuBar bar = new JMenuBar(); //barra dei menù

	//voci principali, ciascuna è un menù
	JMenu fileMenu = new JMenu("File");
	JMenu editMenu = new JMenu("Edit");
	JMenu helpMenu = new JMenu("Help");

	//FILE menù
	JMenuItem newDiagramItem = new JMenuItem("New diagram");
	JMenuItem closeDiagramItem = new JMenuItem("Close diagram");
	JMenuItem saveProjectItem = new JMenuItem("Save project");
	JMenuItem loadProjectItem = new JMenuItem("Load project");
	JMenuItem quitItem = new JMenuItem("Quit");

	//EDIT menù
	JMenu classDiagramMenu = new JMenu("Class Diagram");
	//qui ci vanno le opzioni per scegliere altri diagrammi UML tipo STN ecc...

	//EDIT -> CLASS DIAGRAM menù
	JMenuItem classItem = new JMenuItem("New Class");
	JMenuItem assItem = new JMenuItem("New Association");
	JMenuItem genItem = new JMenuItem("New IS-A");
	JMenuItem removeClassItem = new JMenuItem("Remove Class");
	JMenuItem removeAssItem = new JMenuItem("Remove Association");
	JMenuItem removeGenItem = new JMenuItem("Remove IS-A");
	//JMenuItem specItem = new JMenuItem("Specialization");
	JMenuItem noteItem = new JMenuItem("Note");

	//HELP menù
	JMenuItem classHelp = new JMenuItem("Class diagram help");

	static JTabbedPane jtp = new JTabbedPane();//contiene i tabs per il disegno dei diagrammi

	PrincipaleListener ascoltatore = new PrincipaleListener(this);

	public PrincipaleFrame(){
		super("ReDiaVerifInt - UNIROMA1 - DIS");

		Container c= this.getContentPane();

		//costruzione menu
		this.setJMenuBar(bar);
		bar.add(fileMenu);
		bar.add(editMenu);
		bar.add(helpMenu);

		fileMenu.add(newDiagramItem);
		fileMenu.add(closeDiagramItem);
		fileMenu.addSeparator();
		fileMenu.add(saveProjectItem);
		fileMenu.add(loadProjectItem);
		fileMenu.addSeparator();
		fileMenu.add(quitItem);

		editMenu.add(classDiagramMenu);

		classDiagramMenu.add(classItem);
		classDiagramMenu.add(assItem);
		classDiagramMenu.add(genItem);
		//classDiagramMenu.add(specItem);
		classDiagramMenu.addSeparator();
		classDiagramMenu.add(removeAssItem);
		classDiagramMenu.add(removeClassItem);
		classDiagramMenu.add(removeGenItem);
		classDiagramMenu.addSeparator();
		classDiagramMenu.add(noteItem);

		helpMenu.add(classHelp);

		//costruzione del frame inizialmente vuoto
		c.add(jtp);
		closeDiagramItem.setEnabled(false);
		saveProjectItem.setEnabled(false);
		noteItem.setEnabled(false);
		editMenu.setEnabled(false);
	
		//ascoltatori
		//FILE items
		newDiagramItem.addActionListener(ascoltatore);
		newDiagramItem.setActionCommand(ascoltatore.NEWDIAGRAM);
		closeDiagramItem.addActionListener(ascoltatore);
		closeDiagramItem.setActionCommand(ascoltatore.CLOSEDIAGRAM);
		saveProjectItem.addActionListener(ascoltatore);
		saveProjectItem.setActionCommand(ascoltatore.SAVEPROJECT);
		loadProjectItem.addActionListener(ascoltatore);
		loadProjectItem.setActionCommand(ascoltatore.LOADPROJECT);
		quitItem.addActionListener(ascoltatore);
		quitItem.setActionCommand(ascoltatore.QUIT);
	
		//EDIT -> CLASSDIAGRAM items
		classItem.addActionListener(ascoltatore);
		classItem.setActionCommand(ascoltatore.CLASS);
		assItem.addActionListener(ascoltatore);
		assItem.setActionCommand(ascoltatore.ASSOCIATION);
		genItem.addActionListener(ascoltatore);
		genItem.setActionCommand(ascoltatore.ISA);
		//specItem.addActionListener(ascoltatore);
		//specItem.setActionCommand(ascoltatore.SPECIFICATION);
		//metodi eliminazione
		removeClassItem.addActionListener(ascoltatore);
		removeClassItem.setActionCommand(ascoltatore.DELETECLASS);
		removeAssItem.addActionListener(ascoltatore);
		removeAssItem.setActionCommand(ascoltatore.DELETEASS);
		removeGenItem.addActionListener(ascoltatore);
		removeGenItem.setActionCommand(ascoltatore.DELETEISA);
		//note
		noteItem.addActionListener(ascoltatore);
		noteItem.setActionCommand(ascoltatore.NOTE);

		//HELP items
		classHelp.addActionListener(ascoltatore);
		classHelp.setActionCommand(ascoltatore.HELP1);	

		//operazioni di assestamento finestra
		//this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.addWindowListener(ascoltatore);
		this.setSize(800,600);
		this.setResizable(true);
		FrameUtil.centraFrame(this);
		this.setVisible(true);
		
		JOptionPane.showMessageDialog(this,"ReDiAVeriFInt tool\n" + 
									"Realizzatore Diagrammi Automatico con Verifica Formale Integrata\n" +
									"Click on File men to start");
	}

	public static JTabbedPane getJTP() {
		return jtp;
	}
}
