package it.uniroma1.dis.mfis.redia.verifint.view.graphics.gui.frames.classDiagram;

import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams.CCDDiagram;
import it.uniroma1.dis.mfis.redia.verifint.model.Diagram;
import it.uniroma1.dis.mfis.redia.verifint.control.Archive;
import it.uniroma1.dis.mfis.redia.verifint.control.Application;
import it.uniroma1.dis.mfis.redia.verifint.control.ExecutionProperties;
import it.uniroma1.dis.mfis.redia.verifint.control.provers._constants.Alloy4Constants;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class PrincipaleListener implements ActionListener, WindowListener {

	public static final String NEWDIAGRAM = "NEW";
	public static final String CLOSEDIAGRAM = "CLOSE";
	public static final String SAVEPROJECT = "SAVE";
	public static final String LOADPROJECT = "LOAD";
	public static final String QUIT = "QUIT";
	public static final String CLASS = "CLASS";
	public static final String ASSOCIATION = "ASS";
	public static final String ISA = "GEN";
	public static final String SPECIFICATION = "SPEC";
	public static final String DELETECLASS = "DELETECLASS";
	public static final String DELETEASS = "DELETEASS";
	public static final String DELETEISA = "DELETEISA";
	public static final String NOTE = "NOTE";

	//altri identificatori di diagrammi futuri
	//tipo : "public static final String STNDIAGRAM = "STN";"

	public static final String HELP1 = "HELP1";
	
	private PrincipaleFrame frame;

	public PrincipaleListener(PrincipaleFrame unFrame){
		frame = unFrame;
	}
	
	public void windowClosing(WindowEvent e) {
		quit();
	}
	
	public void windowClosed(WindowEvent e) {}
	
	public void windowOpened(WindowEvent e) {}
	
	public void windowIconified(WindowEvent e) {}
	
	public void windowDeiconified(WindowEvent e) {}
	
	public void windowActivated(WindowEvent e) {}
	
	public void windowDeactivated(WindowEvent e) {}

	public void actionPerformed(ActionEvent e) {
		String com = e.getActionCommand();
		if(com == NEWDIAGRAM) {
			//aggiungi tab
			String tabTitle = JOptionPane.showInputDialog(frame,"Class Diagram name: ");
			if(tabTitle != null) { 
				if(!tabTitle.equals("")) {
					frame.jtp.addTab(tabTitle, new ContentTabPane());
					CCDDiagram classDiagram = new CCDDiagram(tabTitle);
					Archive archive = Archive.getInstance();
					archive.addDiagram(classDiagram);
					if(frame.jtp.getTabCount() > 0) {
						frame.editMenu.setEnabled(true);
						frame.closeDiagramItem.setEnabled(true);
						frame.saveProjectItem.setEnabled(true);
					}
				}
				else JOptionPane.showMessageDialog(frame,"Please insert a valid name");
			}
			else JOptionPane.showMessageDialog(frame,"Cannot create a diagram without name");
		}
		if(com == CLOSEDIAGRAM) {
			//rimuovi il tab selezionato
			Archive archive = Archive.getInstance();
			int tabIndex = frame.jtp.getSelectedIndex();
			String diagramName = frame.jtp.getTitleAt(tabIndex);
			frame.jtp.removeTabAt(tabIndex);
			archive.removeDiagram(diagramName);
 			if(frame.jtp.getTabCount() == 0) {
				frame.editMenu.setEnabled(false);
				frame.closeDiagramItem.setEnabled(false);
				frame.saveProjectItem.setEnabled(false);
			}
		}
		if(com == SAVEPROJECT) {
			Archive archive = Archive.getInstance();
			File directory = new File(ExecutionProperties.getInstance().getProperty(Archive.SAVING_PATH_KEY));
			JFileChooser jfc = new JFileChooser(directory);
			int retVal = jfc.showSaveDialog(frame);
			if(retVal == JFileChooser.APPROVE_OPTION) {
				File file = jfc.getSelectedFile();
				archive.save(file.getName());
			}
		}
		if(com == LOADPROJECT) {
			boolean loaded = false;
			Archive archive = Archive.getInstance();
			File directory = new File(ExecutionProperties.getInstance().getProperty(Archive.SAVING_PATH_KEY));
			JFileChooser jfc = new JFileChooser(directory);
			int retVal = jfc.showOpenDialog(frame);
			if(retVal == JFileChooser.APPROVE_OPTION) {
				File file = jfc.getSelectedFile();
				JOptionPane.showMessageDialog(frame,"Sorry! This function is not yet fully implemented");
				/*
				loaded = archive.load(file.getName());
				if(loaded) {
					ArrayList<Diagram> diagrams = archive.getDiagrams();
					disegnaDiagrammi(diagrams);
				}
				else {
					JOptionPane.showMessageDialog(frame,"Loading file error!");
				}*/
			}
		}
		if(com == CLASS){ 
			ClassFrame cdFrame = new ClassFrame(); // chiamata al metodo creante un diagramma delle classi
		}
		if(com == ASSOCIATION){ 
			AssociationFrame assFrame = new AssociationFrame();
		}
		if(com == ISA){
			new ISAFrame();
		}if(com == DELETECLASS){
			DeleteClassFrame delClass = new DeleteClassFrame();
		}
		if(com == DELETEASS){
			DeleteAssFrame delAss = new DeleteAssFrame();
		}
		if(com == DELETEISA){
			DeleteISAFrame delISa = new DeleteISAFrame();
		}
		if(com == SPECIFICATION){ 
			//non implementato
		}
		if(com == NOTE){ 
			//non implementato
		}		
		if(com == QUIT) {
				quit();
		}
		if(com == HELP1){
			ClassHelpFrame chframe = new ClassHelpFrame();
		}
		//altre opzioni di diagrammi futuri
	}
	
	private void quit() {
		Archive archive = Archive.getInstance();
		if(archive.isUnsaved() && frame.jtp.getTabCount() > 0) {
		int scelta = JOptionPane.NO_OPTION;
		scelta = JOptionPane.showConfirmDialog(frame,"Do you want save current project?");
		if(scelta == JOptionPane.OK_OPTION) {
			File directory = new File(ExecutionProperties.getInstance().getProperty(Archive.SAVING_PATH_KEY));
			JFileChooser jfc = new JFileChooser(directory);
			int retVal = jfc.showSaveDialog(frame);
			if(retVal == JFileChooser.APPROVE_OPTION) {
				File file = jfc.getSelectedFile();
				archive.save(file.getName());
			}
		} 
		else if(scelta == JOptionPane.CANCEL_OPTION) {
			return;
		}
		}
		//chiudi la gui
		frame.dispose();
		//cancella files tmp
		File directory = new File(ExecutionProperties.getInstance().getProperty(Alloy4Constants.ALLOY_4_TMP_PATH_KEY));
		File[] listaFiles = directory.listFiles();
		for(int i = 0; i < listaFiles.length; i++)
			listaFiles[i].delete();
		//termina l'applicazione
		Application.getInstance().term();
	}

	private void disegnaDiagrammi(ArrayList<Diagram> diagrams) {
		Iterator it = diagrams.iterator();
		while(it.hasNext()) {
			CCDDiagram diag = (CCDDiagram)it.next();
			String tabTitle = diag.getName();
			frame.jtp.addTab(tabTitle, new ContentTabPane());
			//TODO diseganre gli oggetti!
			if(frame.jtp.getTabCount() > 0) {
				frame.editMenu.setEnabled(true);
				frame.closeDiagramItem.setEnabled(true);
				frame.saveProjectItem.setEnabled(true);
			}
		}
	}
}

